"""
We have a shared module so that we can bypass the python's issue with parallel processing,
All shared variables will be equivalent to global variables.
They will not be copied when sent to a parallel process.
This avoids overhead in parallel methods where the data matrix is huge and cannot be copied or pickled.
"""

A = None
rel=None
qid=None
NUM_PROCESSES = None
W = None
samples = None
z = None

def update_z(arg):
    global z
    del z
    z = arg
    print("Inside init of shared module: ",id(z))
    

def update_A(arg):
    global A
    del A
    A = arg
    # print("Inside init of shared module: ",id(A))
def update_W(arg):
    global W
    del W
    W = arg

def update_samples(arg):
    global samples
    del samples
    samples = arg

def update_num_proc(num):
    global NUM_PROCESSES
    NUM_PROCESSES=num
