import sys
def import_obj(type):
    if not isinstance(type, str):
        raise ImportError('Object type should be string.')


    mod_str, _sep, class_str = type.rpartition('.')
    try:
        __import__(mod_str)
        return getattr(sys.modules[mod_str], class_str)
    except ModuleNotFoundError:
        raise ModuleNotFoundError('Object {} cannot be found in {}.'.format(class_str, mod_str))